import OutputRedirector
import xwf

# XT_Init is called when a Python X-Tension is called
def XT_Init(nVersion, nFlags, hMainWnd, lpReserved):
    xwf.AllocConsole()
    print('I also opened a console for testing')
    OutputRedirector.install()
    return

# Called just before execution of the Python script concludes
def XT_Done(lpReserved):
   return 

def XT_About(hParentWnd, lpReserved):
   return

def XT_Prepare(hVolume, hEvidence, nOpType, lpReserved):
   return

def XT_Finalize(hVolume, hEvidence, nOpType, lpReserved):
   return

def XT_ProcessSearchHit(iSize, nItemID, nRelOfs, nAbsOfs, lpOptionalHitPtr, lpSearchTermID, nLength, nCodePage, nFlags):
   return

def XT_ProcessItem(nItem, reserved):
   return

def XT_ProcessItemEx(nItem, hItem, reserved):
   str = xwf.GetComment(nItem)
   if len(str) > 0:
      fn = xwf.GetItemName(nItem)
      print('%s has comment %s' % (fn, str))
   else:
      arr = xwf.Read(hItem, 0, 512)
      #print('%i %i' % (arr[0], arr[1]))
      w = arr[18] + 256*arr[19] + 65536*arr[20]
      h = arr[22] + 256*arr[23] + 65536*arr[24] 
      if (arr[0] == 66 and arr[1] == 77):
         xwf.AddComment(nItem, 'BMP %ix%i' % (w,h), 0)
   return

def XT_About(hParentWnd, lpReserved):
   print('Example for a Python script to generate comments\n')
   return
